import React, { Component, Fragment } from 'react';
import 'bootstrap/dist/css/bootstrap.css';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faSearch } from '@fortawesome/free-solid-svg-icons/faSearch';

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var TableFilter = /*#__PURE__*/function (_Component) {
  _inheritsLoose(TableFilter, _Component);

  function TableFilter(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      search: ''
    };
    return _this;
  }

  var _proto = TableFilter.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps, nextContext) {
    this.setState({
      search: nextProps.toChild.searchInput
    });
  };

  _proto.render = function render() {
    return /*#__PURE__*/React.createElement("div", {
      className: "row"
    }, /*#__PURE__*/React.createElement("div", {
      className: "col-4"
    }, /*#__PURE__*/React.createElement("select", {
      className: "form-control-sm form-control",
      onChange: this.props.changeRecordsPerPage.bind(this)
    }, /*#__PURE__*/React.createElement("option", {
      value: 10
    }, "10 records per page"), /*#__PURE__*/React.createElement("option", {
      value: 25
    }, "25 records per page"), /*#__PURE__*/React.createElement("option", {
      value: 50
    }, "50 records per page"), /*#__PURE__*/React.createElement("option", {
      value: 100
    }, "100 records per page"))), /*#__PURE__*/React.createElement("div", {
      className: "col-4 text-center"
    }, /*#__PURE__*/React.createElement("h5", null, /*#__PURE__*/React.createElement("b", null, this.props.tableOptions.table_title))), /*#__PURE__*/React.createElement("div", {
      className: "col-4 text-right padding_right"
    }, /*#__PURE__*/React.createElement("div", {
      className: "input-group input-group-sm"
    }, /*#__PURE__*/React.createElement("div", {
      className: "searchbar"
    }, /*#__PURE__*/React.createElement("input", {
      type: "text",
      className: "search_input effect-1",
      value: this.state.search,
      onChange: this.props.search.bind(this)
    }), /*#__PURE__*/React.createElement("a", {
      href: "#",
      className: "search_icon search-wrapper bg-light"
    }, /*#__PURE__*/React.createElement("i", {
      className: "search-icon bg-light",
      id: "search_icon"
    }, /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      icon: faSearch
    })))))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null));
  };

  return TableFilter;
}(Component);

var PagiNate = /*#__PURE__*/function (_Component) {
  _inheritsLoose(PagiNate, _Component);

  function PagiNate(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      pageNate: [],
      skip: _this.props.skip,
      length: 0,
      take: _this.props.take,
      pageNo: 0
    };
    return _this;
  }

  var _proto = PagiNate.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps, nextContext) {
    var _this2 = this;

    this.setState({
      pagiNate: nextProps.pageNate,
      length: nextProps.pageNate.length,
      skip: nextProps.skip,
      take: nextProps.take
    }, function () {
      console.log('paginate States: ', _this2.state);

      _this2.setState({
        pageNo: _this2.state.skip / _this2.state.take + 1
      }, function () {
        console.log('PageNo :', _this2.state.pageNo);
      });
    });
  };

  _proto.render = function render() {
    var _this3 = this;

    var showingUpTo = 0;

    if (this.state.skip + this.state.take >= this.props.totalTableData) {
      showingUpTo = this.props.totalTableData;
    } else {
      showingUpTo = this.state.skip + this.state.take;
    }

    return /*#__PURE__*/React.createElement("div", {
      className: "row"
    }, /*#__PURE__*/React.createElement("div", {
      className: "col-6"
    }, "Showing ", this.state.skip + 1, " to ", showingUpTo, " of ", this.props.totalTableData, " entries"), /*#__PURE__*/React.createElement("div", {
      className: "col-6 text-right justify-content-end pull-right"
    }, /*#__PURE__*/React.createElement("nav", {
      className: "",
      "aria-label": "Page navigation example text-right"
    }, /*#__PURE__*/React.createElement("ul", {
      className: "pagination justify-content-end"
    }, this.state.pageNo === 1 && /*#__PURE__*/React.createElement("li", {
      className: "page-item disabled"
    }, /*#__PURE__*/React.createElement("a", {
      href: "#",
      className: "page-link",
      "aria-label": "Previous"
    }, /*#__PURE__*/React.createElement("span", {
      "aria-hidden": "true"
    }, "\xAB"), /*#__PURE__*/React.createElement("span", {
      className: "sr-only"
    }, "Previous"))), this.state.pageNo !== 1 && /*#__PURE__*/React.createElement("li", {
      className: "page-item"
    }, /*#__PURE__*/React.createElement("a", {
      href: "#",
      onClick: this.props.paginateMethod.bind(this, this.state.skip - this.state.take),
      className: "page-link",
      "aria-label": "Previous"
    }, /*#__PURE__*/React.createElement("span", {
      "aria-hidden": "true"
    }, "\xAB"), /*#__PURE__*/React.createElement("span", {
      className: "sr-only"
    }, "Previous"))), this.props.pageNate.map(function (item, index) {
      if (item === _this3.state.skip) {
        return /*#__PURE__*/React.createElement("li", {
          className: "page-item active",
          key: index
        }, /*#__PURE__*/React.createElement("a", {
          className: "page-link",
          href: "#"
        }, index + 1));
      } else {
        return /*#__PURE__*/React.createElement("li", {
          className: "page-item",
          key: index
        }, /*#__PURE__*/React.createElement("a", {
          className: "page-link",
          href: "#",
          onClick: _this3.props.paginateMethod.bind(_this3, item)
        }, index + 1));
      }
    }), this.state.pageNo === this.state.length && /*#__PURE__*/React.createElement("li", {
      className: "page-item disabled"
    }, /*#__PURE__*/React.createElement("a", {
      href: "#",
      className: "page-link",
      "aria-label": "Next"
    }, /*#__PURE__*/React.createElement("span", {
      "aria-hidden": "true"
    }, "\xBB"), /*#__PURE__*/React.createElement("span", {
      className: "sr-only"
    }, "Next"))), this.state.pageNo !== this.state.length && /*#__PURE__*/React.createElement("li", {
      className: "page-item"
    }, /*#__PURE__*/React.createElement("a", {
      href: "#",
      onClick: this.props.paginateMethod.bind(this, this.state.take + this.state.skip),
      className: "page-link",
      "aria-label": "Next"
    }, /*#__PURE__*/React.createElement("span", {
      "aria-hidden": "true"
    }, "\xBB"), /*#__PURE__*/React.createElement("span", {
      className: "sr-only"
    }, "Next")))))));
  };

  return PagiNate;
}(Component);

var ReactDataTable = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ReactDataTable, _Component);

  function ReactDataTable(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _this.buttons = function (e) {
      console.log('Functions ', e);
    };

    _this.state = {
      columns: [],
      apiData: [],
      pageNate: [],
      take: 10,
      skip: 0,
      searchInput: '',
      totalTableData: 0
    };
    _this.paginate = _this.paginate.bind(_assertThisInitialized(_this));
    _this.changeRecordsPerPage = _this.changeRecordsPerPage.bind(_assertThisInitialized(_this));
    _this.search = _this.search.bind(_assertThisInitialized(_this));
    _this.onAction = _this.onAction.bind(_assertThisInitialized(_this));
    _this.changeOrder = _this.changeOrder.bind(_assertThisInitialized(_this));
    return _this;
  }

  var _proto = ReactDataTable.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    console.log('props: ', this.props.dataTablesOptions);
    this.setState({
      columns: this.props.dataTablesOptions.colums,
      apiData: this.props.dataTableData.data,
      pageNate: this.props.dataTableData.pageNate,
      totalTableData: this.props.dataTableData.totalTableData
    }, function () {
      _this2.props.dataTableOnChange(_this2.state);
    });
  };

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    this.setState({
      columns: nextProps.dataTablesOptions.colums,
      apiData: nextProps.dataTableData.data,
      pageNate: nextProps.dataTableData.pageNate,
      totalTableData: nextProps.dataTableData.totalTableData
    });
  };

  _proto.changeOrder = function changeOrder(col, e) {
    this.props.dataTableOnChange(this.state);
  };

  _proto.paginate = function paginate(skip, e) {
    var _this3 = this;

    this.setState({
      skip: skip
    }, function () {
      _this3.props.dataTableOnChange(_this3.state);
    });
  };

  _proto.changeRecordsPerPage = function changeRecordsPerPage(e) {
    var _this4 = this;

    this.setState({
      take: e.target.value
    }, function () {
      _this4.props.dataTableOnChange(_this4.state);
    });
  };

  _proto.search = function search(e) {
    var _this5 = this;

    console.log(e.target.value);
    this.setState({
      searchInput: e.target.value
    }, function () {
      _this5.props.dataTableOnChange(_this5.state);
    });
  };

  _proto.onAction = function onAction(e) {
    console.log('You have clicked record no: ');
  };

  _proto.render = function render() {
    var _this6 = this;

    return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(TableFilter, {
      onAction: this.onAction,
      search: this.search,
      searchInput: this.state.searchInput,
      changeRecordsPerPage: this.changeRecordsPerPage,
      filterId: this.state.filterId,
      tableOptions: this.props.dataTablesOptions.tableOptions,
      toChild: this.state
    }), /*#__PURE__*/React.createElement("table", {
      className: "table table-hover"
    }, /*#__PURE__*/React.createElement("thead", null, /*#__PURE__*/React.createElement("tr", null, this.state.columns.map(function (item, index) {
      if (item.column_properties.allowSort === true) {
        return /*#__PURE__*/React.createElement("th", {
          width: item.column_properties.width,
          scope: "col",
          key: index
        }, item.column_properties.title, /*#__PURE__*/React.createElement("a", {
          href: "#",
          onClick: _this6.changeOrder.bind(_this6, item.column_properties.name)
        }, "\xA0", /*#__PURE__*/React.createElement("i", {
          className: "fa fa-sort ",
          "aria-hidden": "true"
        })));
      } else {
        return /*#__PURE__*/React.createElement("th", {
          width: item.column_properties.width,
          scope: "col",
          key: index
        }, item.column_properties.title);
      }
    }))), /*#__PURE__*/React.createElement("tbody", null, this.state.apiData.map(function (item, index) {
      return /*#__PURE__*/React.createElement("tr", {
        key: index
      }, _this6.state.columns.map(function (cols, count) {
        for (var i = 0; i < Object.keys(item).length; i++) {
          console.log('Data Table objects: ', Object.keys(item)[i]);

          if (cols.column_properties.name === Object.keys(item)[i]) {
            console.log('Test Array: ', cols.fa_icon);
            return /*#__PURE__*/React.createElement("td", {
              key: index + i
            }, cols.fa_icon !== undefined && /*#__PURE__*/React.createElement(Fragment, null, cols.fa_icon.map(function (fa, fai) {
              if (fa.show === true) {

                if (fa.extra !== undefined) {
                  console.log('Conditon: ', fa.extra);

                  if (fa.extra.conditional == 'boolean') {
                    console.log('Bolean : ', fa.extra.conditional);

                    if (item[fa.extra.depend_from_this_field] === true) {
                      return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("i", {
                        className: fa.className,
                        onClick: _this6.props.dataTableBtnAction.bind(_this6, item[fa.passValue], fa.actionType),
                        "aria-hidden": "true",
                        style: {
                          cursor: 'pointer'
                        }
                      }), "\xA0");
                    }
                  }
                } else {
                  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("i", {
                    className: fa.className,
                    onClick: _this6.props.dataTableBtnAction.bind(_this6, item[fa.passValue], fa.actionType),
                    "aria-hidden": "true",
                    style: {
                      cursor: 'pointer'
                    }
                  }), "\xA0");
                }
              }
            })), cols.text !== undefined && /*#__PURE__*/React.createElement(Fragment, null, cols.text.map(function (txt, txi) {
              if (txt.show === true) {
                return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("span", {
                  className: txt.className
                }, item[txt.name]), "\xA0");
              }
            })), cols.button !== undefined && /*#__PURE__*/React.createElement(Fragment, null, cols.button.map(function (btn, i) {
              return /*#__PURE__*/React.createElement(Fragment, null, btn.show === true && /*#__PURE__*/React.createElement("button", {
                type: "button",
                event: item,
                id: item.id,
                name: cols.column_properties.name,
                onClick: _this6.props.dataTableBtnAction.bind(_this6, item[btn.passValue], btn.actionType),
                className: btn.className
              }, btn.title), "\xA0");
            })), cols.input !== undefined && /*#__PURE__*/React.createElement(Fragment, null, cols.input.map(function (input, data) {
              if (input.input_type === 'text') {
                return /*#__PURE__*/React.createElement(Fragment, null, input.show === true && /*#__PURE__*/React.createElement("div", {
                  className: "input-group"
                }, /*#__PURE__*/React.createElement("input", {
                  type: input.input_type,
                  name: input.name,
                  id: item.id,
                  className: input.className,
                  onChange: _this6.props.dataTableOnChangeInput.bind(_this6),
                  defaultValue: input.defaultValue
                })), "\xA0");
              } else if (input.input_type === 'checkbox') {
                return /*#__PURE__*/React.createElement(Fragment, null, input.show === true && /*#__PURE__*/React.createElement("input", {
                  type: input.input_type,
                  name: input.name,
                  id: item.id,
                  className: input.className,
                  onChange: _this6.props.dataTableOnChangeInput.bind(_this6),
                  defaultChecked: item.defaultChecked
                }), "\xA0");
              }
            })));
          }
        }
      }));
    }))), /*#__PURE__*/React.createElement(PagiNate, {
      paginateMethod: this.paginate,
      pageNate: this.state.pageNate,
      skip: this.state.skip,
      take: this.state.take,
      totalTableData: this.state.totalTableData
    }));
  };

  return ReactDataTable;
}(Component);

export default ReactDataTable;
//# sourceMappingURL=index.modern.js.map
